--
-- Script DDL de GRHUM pour integration des tables 
-- du framework Evenement à executer depuis le user GRHUM
--
SET DEFINE OFF;

--
-- Ouverture de la version du patch
-- 
-- TODO Libelle de la version !

--INSERT INTO GRHUM.DB_VERSION (DBV_ID, DBV_LIBELLE, DBV_DATE, DBV_INSTALL, DBV_COMMENT)
-- VALUES (GRHUM.DB_VERSION_SEQ.NEXTVAL, '1.0.0.2', SYSDATE,NULL, 'Patch d''installation des tables du framework Evenement.');

--
-- Tables
--
CREATE TABLE GRHUM.EVT_EVENEMENT (
  EVT_ID            number(22) NOT NULL, 
  EVTT_ID           number(22) NOT NULL, 
  EVTE_ID           number(22) NOT NULL, 
  FREQ_ID           number(22), 
  PERSID_CREATION   number(22) NOT NULL, 
  PERSID_MODIF      number(22) NOT NULL, 
  EVT_DATE_CREATION date NOT NULL, 
  EVT_DATE_PREVUE   date NOT NULL, 
  EVT_DATE_MODIF    date NOT NULL, 
  EVT_OBJET         varchar2(1024), 
  EVT_OBSERVATIONS  varchar2(1024), 
  EVT_STATUT        varchar2(64),
  EVT_APP_NAME      varchar2(64),
  CONSTRAINT PK_EVT_EVENEMENT 
    PRIMARY KEY (EVT_ID));
COMMENT ON TABLE GRHUM.EVT_EVENEMENT IS 'C''est la table centrale pour la gestion des évènements!';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT.EVT_ID IS 'Cle primaire de cette table';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT.EVTT_ID IS 'Cle etrangere du type de cet evenement, cf. table EVENEMENT_TYPE';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT.EVTE_ID IS 'Cle etrangere de l''etat de cet evenement, cf. table EVENEMENT_ETAT';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT.FREQ_ID IS 'Clé étrangère de ??? de cet événement, cf. table ???';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT.PERSID_CREATION IS 'Cle etrangere de l''utilisateur ayant cree cet evenement, cf. GRHUM.PERSONNE';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT.PERSID_MODIF IS 'Cle etrangere de l''utilisateur ayant modifie cet evenement, cf. GRHUM.PERSONNE';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT.EVT_DATE_CREATION IS 'Date de creation de cet evenement';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT.EVT_DATE_PREVUE IS 'Date et heure prevues de cet evenement, passee ou future';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT.EVT_DATE_MODIF IS 'Date de modification de cet evenement';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT.EVT_OBJET IS 'Objet, intitule, motif de cet evenement';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT.EVT_OBSERVATIONS IS 'Observations, remarques eventuelles concernant cet evenement';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT.EVT_STATUT IS 'Statut de cet evenement, ex: prevu, realise';

CREATE TABLE GRHUM.EVT_EVENEMENT_EXT_JURI (
  EVT_EXT_JURI_ID  number(22) NOT NULL, 
  EVT_ID           number(22) NOT NULL, 
  EVT_PERSID_RESP_JURIDIQUE   number(22) NOT NULL, 
  EVT_AVIS         varchar2(64), 
  EVT_CONTEXTE     varchar2(1024), 
  CONSTRAINT PK_EVT_EVENEMENT_EXT_JURI 
    PRIMARY KEY (EVT_EXT_JURI_ID));
COMMENT ON TABLE GRHUM.EVT_EVENEMENT IS 'Table d''extension pour les évènements de type juridique';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT_EXT_JURI.EVT_EXT_JURI_ID IS 'Cle primaire de cette table';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT_EXT_JURI.EVT_ID IS 'Cle etrangere de l''evenement, cf. table EVT_EVENEMENT';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT_EXT_JURI.EVT_AVIS IS 'Avis sur l''evenement juridique';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT_EXT_JURI.EVT_CONTEXTE IS 'Contexte de l''evenement juridique';

CREATE TABLE GRHUM.EVT_EVENEMENT_DOCUMENT (
  EDOC_ID    number(22) NOT NULL, 
  EVT_ID     number(22) NOT NULL, 
  RDOC_ID    number(22), 
  COU_NUMERO number(22) NOT NULL, 
  CONSTRAINT PK_EVT_EVENEMENT_DOCUMENT 
    PRIMARY KEY (EDOC_ID));
COMMENT ON TABLE GRHUM.EVT_EVENEMENT_DOCUMENT IS 'Table de repartition des documents (courriers) associes a des evenements';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT_DOCUMENT.EDOC_ID IS 'Cle primaire';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT_DOCUMENT.EVT_ID IS 'Cle etrangere de l''evenement, cf. table EVENEMENT';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT_DOCUMENT.RDOC_ID IS 'Cle etrangere du role joue par le document, cf. table ROLE_DOCUMENT';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT_DOCUMENT.COU_NUMERO IS 'Cle etrangere du document, cf. table COURRIER.COURRIER';

CREATE TABLE GRHUM.EVT_EVENEMENT_ETAT (
  EVTE_ID              number(22) NOT NULL, 
  EVTE_ID_INTERNE      varchar2(32) NOT NULL, 
  EVTE_ORDRE_AFFICHAGE number(22), 
  EVTE_LC              varchar2(128) NOT NULL, 
  EVTE_LL              varchar2(256) NOT NULL, 
  CONSTRAINT PK_EVT_EVENEMENT_ETAT 
    PRIMARY KEY (EVTE_ID));
COMMENT ON TABLE GRHUM.EVT_EVENEMENT_ETAT IS 'Etats possibles pour un evenement';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT_ETAT.EVTE_ID IS 'Cle primaire de cette table';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT_ETAT.EVTE_ID_INTERNE IS 'Id interne, a utiliser pour les fetch (plutot que la cle primaire)';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT_ETAT.EVTE_ORDRE_AFFICHAGE IS 'Numero utilise pour ordonner le contenu de cette table';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT_ETAT.EVTE_LC IS 'Libelle, intitule court';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT_ETAT.EVTE_LL IS 'Libelle, intitule complet';

CREATE TABLE GRHUM.EVT_EVENEMENT_PERSONNE (
  EPERS_ID     number(22) NOT NULL, 
  EVT_ID       number(22) NOT NULL, 
  RPER_ID      number(22), 
  PERS_ID      number(22) NOT NULL, 
  EPER_ALERTER varchar2(64), 
  CONSTRAINT PK_EVT_EVENEMENT_PERSONNE 
    PRIMARY KEY (EPERS_ID));
COMMENT ON TABLE GRHUM.EVT_EVENEMENT_PERSONNE IS 'Table de repartition des personnes concernees par des evenements';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT_PERSONNE.EPERS_ID IS 'Cle primaire de cette table';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT_PERSONNE.EVT_ID IS 'Cle etrangere de l''evenement, cf. table EVENEMENT';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT_PERSONNE.RPER_ID IS 'Cle etrangere du role joue par la personne, cf. table ROLE_PERSONNE';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT_PERSONNE.PERS_ID IS 'Clé étrangère de la personne. cf. GRHUM.INDIVIDU ou GRHUM.STRUCTURE';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT_PERSONNE.EPER_ALERTER IS 'Témoin spécifiant si la personne doit être alertée ou pas.';

CREATE TABLE GRHUM.EVT_EVENEMENT_TYPE (
  EVTT_ID              number(22) NOT NULL, 
  EVTT_ID_INTERNE      varchar2(32) NOT NULL, 
  EVTT_ORDRE_AFFICHAGE number(22), 
  EVTT_LC              varchar2(128) NOT NULL, 
  EVTT_LL              varchar2(256) NOT NULL,
  EVTT_CAT_ID          number(22) NOT NULL, 
  CONSTRAINT PK_EVT_EVENEMENT_TYPE 
    PRIMARY KEY (EVTT_ID));
COMMENT ON TABLE GRHUM.EVT_EVENEMENT_TYPE IS 'Types possibles d''evenement';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT_TYPE.EVTT_ID IS 'Cle primaire de cette table';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT_TYPE.EVTT_ID_INTERNE IS 'Id interne, a utiliser pour les fetch (plutot que la cle primaire)';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT_TYPE.EVTT_ORDRE_AFFICHAGE IS 'Numero utilise pour ordonner le contenu de cette table';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT_TYPE.EVTT_LC IS 'Libelle, intitule court';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT_TYPE.EVTT_LL IS 'Libelle, intitule complet';

CREATE TABLE GRHUM.EVT_EVENEMENT_TYPE_CAT (
  EVTT_CAT_ID              number(22) NOT NULL, 
  EVTT_CAT_ID_INTERNE      varchar2(32) NOT NULL, 
  EVTT_CAT_LC              varchar2(128) NOT NULL, 
  EVTT_CAT_LL              varchar2(256) NOT NULL, 
  CONSTRAINT PK_EVT_EVENEMENT_TYPE_CAT 
    PRIMARY KEY (EVTT_CAT_ID));
COMMENT ON TABLE GRHUM.EVT_EVENEMENT_TYPE_CAT IS 'Categories de types d''evenement';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT_TYPE_CAT.EVTT_CAT_ID IS 'Cle primaire de cette table';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT_TYPE_CAT.EVTT_CAT_ID_INTERNE IS 'Id interne, a utiliser pour les fetch (plutot que la cle primaire)';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT_TYPE_CAT.EVTT_CAT_LC IS 'Libelle, intitule court';
COMMENT ON COLUMN GRHUM.EVT_EVENEMENT_TYPE_CAT.EVTT_CAT_LL IS 'Libelle, intitule complet';


CREATE TABLE GRHUM.EVT_FREQUENCE_CRON (
  FRQC_ID              number(22) NOT NULL, 
  REP_ID               number(22) NOT NULL, 
  EVT_ID               number(22) NOT NULL, 
  FRQC_DATE_FIN        date, 
  FRQC_CRON_EXPRESSION varchar2(256) NOT NULL, 
  FRQC_TRADUCTION      varchar2(1024) NOT NULL, 
  FRQC_LASTDAYOFWEEK   varchar2(32) NOT NULL, 
  FRQC_DAYSOFMONTH     varchar2(256) NOT NULL, 
  FRQC_MONTHS          varchar2(256) NOT NULL, 
  FRQC_DAYSOFWEEK      varchar2(256) NOT NULL, 
  FRQC_NTHDAYOFWEEK    varchar2(16) NOT NULL, 
  FRQC_LASTDAYOFMONTH  varchar2(32) NOT NULL, 
  FRQC_NEARESTWEEKDAY  varchar2(32) NOT NULL, 
  FRQC_YEARS           varchar2(256) NOT NULL, 
  FRQC_HOURS           varchar2(256) NOT NULL, 
  FRQC_MINUTES         varchar2(256) NOT NULL, 
  FRQC_SECONDS         varchar2(256) NOT NULL, 
  CONSTRAINT PK_EVT_FREQUENCE_CRON 
    PRIMARY KEY (FRQC_ID));
COMMENT ON TABLE GRHUM.EVT_FREQUENCE_CRON IS 'Specifications des frequences de type CRON';
COMMENT ON COLUMN GRHUM.EVT_FREQUENCE_CRON.FRQC_ID IS 'Cle primaire de cette table';
COMMENT ON COLUMN GRHUM.EVT_FREQUENCE_CRON.EVT_ID IS 'Cle etrangere de l''evenement, cf. table EVENEMENT';
COMMENT ON COLUMN GRHUM.EVT_FREQUENCE_CRON.FRQC_CRON_EXPRESSION IS 'Specification de la frequence par une expression CRON';
COMMENT ON COLUMN GRHUM.EVT_FREQUENCE_CRON.FRQC_TRADUCTION IS 'Signification en francais de la periodicite correspondante';

CREATE TABLE GRHUM.EVT_FREQUENCE_SIMPLE (
  FRQS_ID              number(22) NOT NULL, 
  REP_ID               number(22) NOT NULL, 
  EVT_ID               number(22) NOT NULL, 
  FRQS_DATE_FIN        date, 
  FRQS_REPEAT_COUNT    number(22) NOT NULL, 
  FRQS_REPEAT_INTERVAL number(22) NOT NULL, 
  FRQS_TRADUCTION      varchar2(1024) NOT NULL, 
  CONSTRAINT PK_EVT_FREQUENCE_SIMPLE 
    PRIMARY KEY (FRQS_ID));
COMMENT ON TABLE GRHUM.EVT_FREQUENCE_SIMPLE IS 'Specifications des frequences de type simple';
COMMENT ON COLUMN GRHUM.EVT_FREQUENCE_SIMPLE.FRQS_ID IS 'Cle primaire de cette table';
COMMENT ON COLUMN GRHUM.EVT_FREQUENCE_SIMPLE.EVT_ID IS 'Cle etrangere de l''evenement, cf. table EVENEMENT';
COMMENT ON COLUMN GRHUM.EVT_FREQUENCE_SIMPLE.FRQS_REPEAT_COUNT IS 'Nombre de repetition';
COMMENT ON COLUMN GRHUM.EVT_FREQUENCE_SIMPLE.FRQS_REPEAT_INTERVAL IS 'Valeur de l''interval entre chaque repetition, en millisecondes';
COMMENT ON COLUMN GRHUM.EVT_FREQUENCE_SIMPLE.FRQS_TRADUCTION IS 'Signification en francais de la periodicite correspondante';

CREATE TABLE GRHUM.EVT_PARAMETRES (
  PARAM_ORDRE        number(22) NOT NULL, 
  PARAM_KEY          varchar2(64) NOT NULL, 
  PARAM_VALUE        varchar2(128) NOT NULL, 
  PARAM_COMMENTAIRES varchar2(256), 
  CONSTRAINT PK_EVT_PARAMETRES 
    PRIMARY KEY (PARAM_ORDRE));
COMMENT ON TABLE GRHUM.EVT_PARAMETRES IS 'Liste des parametres utilises par l''application de gestion des évenements.';
COMMENT ON COLUMN GRHUM.EVT_PARAMETRES.PARAM_ORDRE IS 'Cle primaire de la table';
COMMENT ON COLUMN GRHUM.EVT_PARAMETRES.PARAM_KEY IS 'Nom de la cle du parametre';
COMMENT ON COLUMN GRHUM.EVT_PARAMETRES.PARAM_VALUE IS 'Valeur du parametre';
COMMENT ON COLUMN GRHUM.EVT_PARAMETRES.PARAM_COMMENTAIRES IS 'Commentaires explicatifs, valeurs possibles...';

CREATE TABLE GRHUM.EVT_REPETITION (
  REP_ID              number(22) NOT NULL, 
  REP_ID_INTERNE      varchar2(32) NOT NULL, 
  REP_ORDRE_AFFICHAGE number(22), 
  REP_LC              varchar2(128) NOT NULL, 
  REP_LL              varchar2(256) NOT NULL, 
  CONSTRAINT PK_EVT_REPETITION 
    PRIMARY KEY (REP_ID));
COMMENT ON TABLE GRHUM.EVT_REPETITION IS 'Type de périodicité possibles, par exemple par jour, par semaine, par mois etc....';
COMMENT ON COLUMN GRHUM.EVT_REPETITION.REP_ID IS 'Cle primaire de cette table';
COMMENT ON COLUMN GRHUM.EVT_REPETITION.REP_ID_INTERNE IS 'Id interne, a utiliser pour les fetch (plutot que la cle primaire)';
COMMENT ON COLUMN GRHUM.EVT_REPETITION.REP_ORDRE_AFFICHAGE IS 'Numero utilise pour ordonner le contenu de cette table';
COMMENT ON COLUMN GRHUM.EVT_REPETITION.REP_LC IS 'Libelle, intitule court';
COMMENT ON COLUMN GRHUM.EVT_REPETITION.REP_LL IS 'Libelle, intitule complet';

CREATE TABLE GRHUM.EVT_ROLE_DOCUMENT (
  RDOC_ID              number(22) NOT NULL, 
  RDOC_ID_INTERNE      varchar2(32) NOT NULL, 
  RDOC_ORDRE_AFFICHAGE number(22), 
  RDOC_LC              varchar2(64) NOT NULL, 
  RDOC_LL              varchar2(256) NOT NULL, 
  CONSTRAINT PK_EVT_ROLE_DOCUMENT 
    PRIMARY KEY (RDOC_ID));
COMMENT ON TABLE GRHUM.EVT_ROLE_DOCUMENT IS 'Roles possibles joues par un document vis a vis d''un evenement';
COMMENT ON COLUMN GRHUM.EVT_ROLE_DOCUMENT.RDOC_ID IS 'Cle primaire de cette table';
COMMENT ON COLUMN GRHUM.EVT_ROLE_DOCUMENT.RDOC_ID_INTERNE IS 'Id interne, a utiliser pour les fetch (plutot que la cle primaire)';
COMMENT ON COLUMN GRHUM.EVT_ROLE_DOCUMENT.RDOC_ORDRE_AFFICHAGE IS 'Numero utilise pour ordonner le contenu de cette table';
COMMENT ON COLUMN GRHUM.EVT_ROLE_DOCUMENT.RDOC_LC IS 'Libelle, intitule court';
COMMENT ON COLUMN GRHUM.EVT_ROLE_DOCUMENT.RDOC_LL IS 'Libelle, intitule complet';

CREATE TABLE GRHUM.EVT_ROLE_PERSONNE (
  RPER_ID              number(22) NOT NULL, 
  RPER_ID_INTERNE      varchar2(32) NOT NULL, 
  RPER_ORDRE_AFFICHAGE number(22), 
  RPER_LC              varchar2(64) NOT NULL, 
  RPER_LL              varchar2(256) NOT NULL, 
  CONSTRAINT PK_EVT_ROLE_PERSONNE 
    PRIMARY KEY (RPER_ID));
COMMENT ON TABLE GRHUM.EVT_ROLE_PERSONNE IS 'Roles possibles joues par une personne (concernee) vis a vis d''un evenement';
COMMENT ON COLUMN GRHUM.EVT_ROLE_PERSONNE.RPER_ID IS 'Cle primaire de cette table';
COMMENT ON COLUMN GRHUM.EVT_ROLE_PERSONNE.RPER_ID_INTERNE IS 'Id interne, a utiliser pour les fetch (plutot que la cle primaire)';
COMMENT ON COLUMN GRHUM.EVT_ROLE_PERSONNE.RPER_ORDRE_AFFICHAGE IS 'Numero utilise pour ordonner le contenu de cette table';
COMMENT ON COLUMN GRHUM.EVT_ROLE_PERSONNE.RPER_LC IS 'Libelle, intitule court';
COMMENT ON COLUMN GRHUM.EVT_ROLE_PERSONNE.RPER_LL IS 'Libelle, intitule complet';

CREATE TABLE GRHUM.EVT_TACHE (
  TACH_ID                     number(22) NOT NULL, 
  TYTA_ID                     number(22) NOT NULL, 
  EVT_ID                      number(22) NOT NULL, 
  PERSID_CREATION             number(22) NOT NULL, 
  PERSID_MODIF                number(22), 
  TACH_DATE_MODIF             date, 
  TACH_DATE_CREATION          date NOT NULL, 
  TACH_TRIGGER_OFFSET_MINUTES number(22), 
  TACH_CLASS_NAME             varchar2(128) NOT NULL, 
  TACH_GROUP                  varchar2(80) NOT NULL, 
  TACH_NAME                   varchar2(80) NOT NULL, 
  TACH_DESCRIPTION            varchar2(128), 
  TACH_SEND_MAIL_AFTER_EXE    varchar2(64), 
  TACH_ETAT                   varchar2(64), 
  TACH_DATA                   blob, 
  CONSTRAINT PK_EVT_TACHE 
    PRIMARY KEY (TACH_ID));
COMMENT ON TABLE GRHUM.EVT_TACHE IS 'Taches (jobs potentiels) associees a des evenements';
COMMENT ON COLUMN GRHUM.EVT_TACHE.TACH_ID IS 'Cle primaire de cette table';
COMMENT ON COLUMN GRHUM.EVT_TACHE.TYTA_ID IS 'Cle etrangere du type de cette tache, cf. table TYPE_TACHE';
COMMENT ON COLUMN GRHUM.EVT_TACHE.EVT_ID IS 'Cle etrangere de l''evenement, cf. table EVENEMENT';
COMMENT ON COLUMN GRHUM.EVT_TACHE.PERSID_CREATION IS 'Cle etrangere de l''utilisateur ayant cree cette tache, cf. GRHUM.PERSONNE';
COMMENT ON COLUMN GRHUM.EVT_TACHE.PERSID_MODIF IS 'Cle etrangere de l''utilisateur ayant cree cette tache, cf. GRHUM.PERSONNE';
COMMENT ON COLUMN GRHUM.EVT_TACHE.TACH_DATE_MODIF IS 'Date de modification de cette tache';
COMMENT ON COLUMN GRHUM.EVT_TACHE.TACH_DATE_CREATION IS 'Date de creation de cette tache';
COMMENT ON COLUMN GRHUM.EVT_TACHE.TACH_TRIGGER_OFFSET_MINUTES IS 'Decalage en minutes a appliquer au declenchement de la tache, par rapport a la date/heure prevue de l''evenement, ex: "-5" <=> "5 minutes avant"';
COMMENT ON COLUMN GRHUM.EVT_TACHE.TACH_CLASS_NAME IS 'Nom complet de la classe (job) qui sera instanciee par le scheduler Quartz';
COMMENT ON COLUMN GRHUM.EVT_TACHE.TACH_GROUP IS 'Nom du groupe de cette tache, repris dans la creation du job Quartz';
COMMENT ON COLUMN GRHUM.EVT_TACHE.TACH_NAME IS 'Nom de cette tache, repris dans la creation du job Quartz';
COMMENT ON COLUMN GRHUM.EVT_TACHE.TACH_DESCRIPTION IS 'Description de ce que fait cette tache';
COMMENT ON COLUMN GRHUM.EVT_TACHE.TACH_SEND_MAIL_AFTER_EXE IS 'Indique si un accuse d''execution doit etre envoye par mail aux personnes concernees: OUI/NON';
COMMENT ON COLUMN GRHUM.EVT_TACHE.TACH_ETAT IS 'Etat de programmation de cette tache';
COMMENT ON COLUMN GRHUM.EVT_TACHE.TACH_DATA IS 'Donnees supplementaires eventuelles passees au job Quartz';

CREATE TABLE GRHUM.EVT_TYPE_TACHE (
  TYTA_ID              number(22) NOT NULL, 
  TYTA_ID_INTERNE      varchar2(32) NOT NULL, 
  TYTA_ORDRE_AFFICHAGE number(22), 
  TYTA_VISIBILITE      varchar2(32), 
  TYTA_LC              varchar2(128) NOT NULL, 
  TYTA_LL              varchar2(256) NOT NULL, 
  CONSTRAINT PK_EVT_TYPE_TACHE 
    PRIMARY KEY (TYTA_ID));
COMMENT ON TABLE GRHUM.EVT_TYPE_TACHE IS 'Types possibles pour un tache';
COMMENT ON COLUMN GRHUM.EVT_TYPE_TACHE.TYTA_ID IS 'Cle primaire de cette table';
COMMENT ON COLUMN GRHUM.EVT_TYPE_TACHE.TYTA_ID_INTERNE IS 'Id interne, a utiliser pour les fetch (plutot que la cle primaire)';
COMMENT ON COLUMN GRHUM.EVT_TYPE_TACHE.TYTA_ORDRE_AFFICHAGE IS 'Numero utilise pour ordonner le contenu de cette table';
COMMENT ON COLUMN GRHUM.EVT_TYPE_TACHE.TYTA_LC IS 'Libelle, intitule court';
COMMENT ON COLUMN GRHUM.EVT_TYPE_TACHE.TYTA_LL IS 'Libelle, intitule complet';

--
-- Contraintes Foreign Key
--
ALTER TABLE GRHUM.EVT_EVENEMENT ADD CONSTRAINT FK_EVENEMENT_TYPE FOREIGN KEY (EVTT_ID) REFERENCES GRHUM.EVT_EVENEMENT_TYPE (EVTT_ID);
ALTER TABLE GRHUM.EVT_EVENEMENT ADD CONSTRAINT FK_EVENEMENT_ETAT FOREIGN KEY (EVTE_ID) REFERENCES GRHUM.EVT_EVENEMENT_ETAT (EVTE_ID);
ALTER TABLE GRHUM.EVT_EVENEMENT_TYPE ADD CONSTRAINT FK_EVENEMENT_TYPE_CAT FOREIGN KEY (EVTT_CAT_ID) REFERENCES GRHUM.EVT_EVENEMENT_TYPE_CAT (EVTT_CAT_ID);
ALTER TABLE GRHUM.EVT_EVENEMENT_DOCUMENT ADD CONSTRAINT FK_ROLE_DOCUMENT_EVT FOREIGN KEY (EVT_ID) REFERENCES GRHUM.EVT_EVENEMENT (EVT_ID);
ALTER TABLE GRHUM.EVT_EVENEMENT_DOCUMENT ADD CONSTRAINT FK_ROLE_DOCUMENT FOREIGN KEY (RDOC_ID) REFERENCES GRHUM.EVT_ROLE_DOCUMENT (RDOC_ID);
ALTER TABLE GRHUM.EVT_EVENEMENT_PERSONNE ADD CONSTRAINT FK_EVENEMENT_PERS_EVT FOREIGN KEY (EVT_ID) REFERENCES GRHUM.EVT_EVENEMENT (EVT_ID);
ALTER TABLE GRHUM.EVT_EVENEMENT_PERSONNE ADD CONSTRAINT FK_ROLE_PERSONNE FOREIGN KEY (RPER_ID) REFERENCES GRHUM.EVT_ROLE_PERSONNE (RPER_ID);
ALTER TABLE GRHUM.EVT_FREQUENCE_CRON ADD CONSTRAINT FK_FREQ_CRON_REPETITION FOREIGN KEY (REP_ID) REFERENCES GRHUM.EVT_REPETITION (REP_ID);
ALTER TABLE GRHUM.EVT_FREQUENCE_CRON ADD CONSTRAINT FK_FREQUENCE_CRON_EVT FOREIGN KEY (EVT_ID) REFERENCES GRHUM.EVT_EVENEMENT (EVT_ID);
ALTER TABLE GRHUM.EVT_FREQUENCE_SIMPLE ADD CONSTRAINT FK_FREQ_SIMPLE_REPETITION FOREIGN KEY (REP_ID) REFERENCES GRHUM.EVT_REPETITION (REP_ID);
ALTER TABLE GRHUM.EVT_FREQUENCE_SIMPLE ADD CONSTRAINT FK_FREQUENCE_SIMPLE_EVT FOREIGN KEY (EVT_ID) REFERENCES GRHUM.EVT_EVENEMENT (EVT_ID);
ALTER TABLE GRHUM.EVT_TACHE ADD CONSTRAINT FK_TYPE_TACHE FOREIGN KEY (TYTA_ID) REFERENCES GRHUM.EVT_TYPE_TACHE (TYTA_ID);
ALTER TABLE GRHUM.EVT_TACHE ADD CONSTRAINT FK_TACHE_EVT FOREIGN KEY (EVT_ID) REFERENCES GRHUM.EVT_EVENEMENT (EVT_ID);
ALTER TABLE GRHUM.EVT_EVENEMENT_EXT_JURI ADD CONSTRAINT FK_EVT_EXT_JURI_EVENEMENT FOREIGN KEY (EVT_ID) REFERENCES GRHUM.EVT_EVENEMENT (EVT_ID);

--
-- Indexes
--
CREATE INDEX IDX_EVT_EVTE_ID ON GRHUM.EVT_EVENEMENT (EVTE_ID);
CREATE INDEX IDX_EVT_EVTT_ID ON GRHUM.EVT_EVENEMENT (EVTT_ID);
CREATE INDEX IDX_EVT_FREQ_ID ON GRHUM.EVT_EVENEMENT (FREQ_ID);
CREATE INDEX IDX_EVT_DOC_COU_NUMERO ON GRHUM.EVT_EVENEMENT_DOCUMENT (COU_NUMERO);
CREATE INDEX IDX_EVT_DOC_RDRO_ID ON GRHUM.EVT_EVENEMENT_DOCUMENT (RDOC_ID);
CREATE INDEX IDX_EVT_DOC_EVT_ID ON GRHUM.EVT_EVENEMENT_DOCUMENT (EVT_ID);
CREATE UNIQUE INDEX IDX_EVT_ETAT_EVTE_ID_INTERNE ON GRHUM.EVT_EVENEMENT_ETAT (EVTE_ID_INTERNE);
CREATE INDEX IDX_EVT_PERS_RPER_ID ON GRHUM.EVT_EVENEMENT_PERSONNE (RPER_ID);
--CREATE INDEX IDX_EVT_PERS_EPERS_ID ON GRHUM.EVT_EVENEMENT_PERSONNE (EPERS_ID);
CREATE INDEX IDX_EVT_PERS_EVT_ID ON GRHUM.EVT_EVENEMENT_PERSONNE (EVT_ID);
CREATE UNIQUE INDEX IDX_EVT_TYPE_EVTT_ID_INTERNE ON GRHUM.EVT_EVENEMENT_TYPE (EVTT_ID_INTERNE);
CREATE UNIQUE INDEX IDX_EVT_TYPE_EVTT_CAT_ID_INT ON GRHUM.EVT_EVENEMENT_TYPE_CAT (EVTT_CAT_ID_INTERNE);
CREATE UNIQUE INDEX IDX_PARAMETRES_PARAM_KEY ON GRHUM.EVT_PARAMETRES (PARAM_KEY);
CREATE UNIQUE INDEX IDX_REPETITION_REP_ID_INTERNE ON GRHUM.EVT_REPETITION (REP_ID_INTERNE);
CREATE UNIQUE INDEX IDX_ROLE_DOC_RDOC_ID_INTERNE ON GRHUM.EVT_ROLE_DOCUMENT (RDOC_ID_INTERNE);
CREATE UNIQUE INDEX IDX_ROLE_PERS_RPER_ID_INTERNE ON GRHUM.EVT_ROLE_PERSONNE (RPER_ID_INTERNE);
CREATE INDEX IDX_TACHE_EVT_ID ON GRHUM.EVT_TACHE (EVT_ID);
CREATE UNIQUE INDEX IDX_TYPE_TACHE_TYTA_ID_INTERNE ON GRHUM.EVT_TYPE_TACHE (TYTA_ID_INTERNE);
CREATE UNIQUE INDEX IDX_EVT_EXT_JURY ON GRHUM.EVT_EVENEMENT_EXT_JURI (EVT_ID);

--
-- Sequences
--
CREATE SEQUENCE GRHUM.EVT_EVENEMENT_SEQ INCREMENT BY 1 MINVALUE 1 NOCYCLE CACHE 20 NOORDER;
CREATE SEQUENCE GRHUM.EVT_EVENEMENT_EXT_JURI_SEQ INCREMENT BY 1 MINVALUE 1 NOCYCLE CACHE 20 NOORDER;
CREATE SEQUENCE GRHUM.EVT_ROLE_DOCUMENT_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE CACHE 20 NOORDER;
CREATE SEQUENCE GRHUM.EVT_EVENEMENT_DOCUMENT_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE CACHE 20 NOORDER;
CREATE SEQUENCE GRHUM.EVT_EVENEMENT_ETAT_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE CACHE 20 NOORDER;
CREATE SEQUENCE GRHUM.EVT_ROLE_PERSONNE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE CACHE 20 NOORDER;
CREATE SEQUENCE GRHUM.EVT_EVENEMENT_PERSONNE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE CACHE 20 NOORDER;
CREATE SEQUENCE GRHUM.EVT_FREQUENCE_CRON_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE CACHE 20 NOORDER;
CREATE SEQUENCE GRHUM.EVT_FREQUENCE_SIMPLE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE CACHE 20 NOORDER;
CREATE SEQUENCE GRHUM.EVT_REPETITION_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE CACHE 20 NOORDER;
CREATE SEQUENCE GRHUM.EVT_EVENEMENT_TYPE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE CACHE 20 NOORDER;
CREATE SEQUENCE GRHUM.EVT_EVENEMENT_TYPE_CAT_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE CACHE 20 NOORDER;
CREATE SEQUENCE GRHUM.EVT_TACHE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE CACHE 20 NOORDER;
CREATE SEQUENCE GRHUM.EVT_TYPE_TACHE_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE CACHE 20 NOORDER;
CREATE SEQUENCE GRHUM.EVT_PARAMETRES_SEQ START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCYCLE CACHE 20 NOORDER;
